diff --git a/src/backend/optimizer/path/joinpath.c b/src/backend/optimizer/path/joinpath.c
index 02a6302..aa3362b 100644
--- a/src/backend/optimizer/path/joinpath.c
+++ b/src/backend/optimizer/path/joinpath.c
@@ -916,6 +1506,16 @@ sort_inner_and_outer(PlannerInfo *root,
 	 */
 	if (jointype == JOIN_UNIQUE_OUTER)
 	{
+		/*
+		 * TODO This is just a temporary limitation. Before lifting it, make
+		 * sure that the UniquePath does emit GroupedVars. Also try to avoid
+		 * the unique-ification if outer_path comes directly from AggPath
+		 * (i.e. it's not grouped path combined with plain one) and the
+		 * grouping keys guaranteed the uniqueness.
+		 */
+		if (grouped_outer)
+			return;
+
 		outer_path = (Path *) create_unique_path(root, outerrel,
 												 outer_path, extra->sjinfo);
 		Assert(outer_path);
@@ -923,6 +1523,10 @@ sort_inner_and_outer(PlannerInfo *root,
 	}
 	else if (jointype == JOIN_UNIQUE_INNER)
 	{
+		/* TODO Temporary limitation, like above. */
+		if (grouped_inner)
+			return;
+
 		inner_path = (Path *) create_unique_path(root, innerrel,
 												 inner_path, extra->sjinfo);
 		Assert(inner_path);
@@ -944,13 +1548,50 @@ sort_inner_and_outer(PlannerInfo *root,
 		outerrel->partial_pathlist != NIL &&
 		bms_is_empty(joinrel->lateral_relids))
 	{
-		cheapest_partial_outer = (Path *) linitial(outerrel->partial_pathlist);
+		if (grouped_outer)
+		{
+			if (REL_HAS_PARTIAL_GROUPED_PATHS(outerrel))
+				cheapest_partial_outer = (Path *)
+					linitial(outerrel->gpi->partial_pathlist);
+			else
+				return;
+		}
+		else
+			cheapest_partial_outer = (Path *)
+				linitial(outerrel->partial_pathlist);
+
+		if (grouped_inner)
+		{
+			if (REL_HAS_GROUPED_PATHS(innerrel))
+				inner_path = linitial(innerrel->gpi->pathlist);
+			else
+				return;
+		}
+		else
+			inner_path = innerrel->cheapest_total_path;
 
 		if (inner_path->parallel_safe)
 			cheapest_safe_inner = inner_path;
 		else if (save_jointype != JOIN_UNIQUE_INNER)
+		{
+			List	   *inner_pathlist;
+
+			if (!grouped_inner)
+				inner_pathlist = innerrel->pathlist;
+			else
+			{
+				Assert(innerrel->gpi != NULL);
+				inner_pathlist = innerrel->gpi->pathlist;
+			}
+
+			/*
+			 * All the grouped paths should be unparameterized, so the
+			 * function is overly stringent in the grouped_inner case, but
+			 * still useful.
+			 */
 			cheapest_safe_inner =
-				get_cheapest_parallel_safe_total_inner(innerrel->pathlist);
+				get_cheapest_parallel_safe_total_inner(inner_pathlist);
+		}
 	}
 
 	/*
@@ -1026,33 +1667,24 @@ sort_inner_and_outer(PlannerInfo *root,
 		 * properly.  try_mergejoin_path will detect that case and suppress an
 		 * explicit sort step, so we needn't do so here.
 		 */
-		try_mergejoin_path(root,
-						   joinrel,
-						   outer_path,
-						   inner_path,
-						   merge_pathkeys,
-						   cur_mergeclauses,
-						   outerkeys,
-						   innerkeys,
-						   jointype,
-						   extra,
-						   false);
+		try_mergejoin_path_common(root, joinrel, outer_path, inner_path,
+								  merge_pathkeys, cur_mergeclauses,
+								  outerkeys, innerkeys, jointype, extra,
+								  false, grouped_outer, grouped_inner,
+								  do_aggregate);
 
 		/*
 		 * If we have partial outer and parallel safe inner path then try
 		 * partial mergejoin path.
 		 */
 		if (cheapest_partial_outer && cheapest_safe_inner)
-			try_partial_mergejoin_path(root,
-									   joinrel,
-									   cheapest_partial_outer,
-									   cheapest_safe_inner,
-									   merge_pathkeys,
-									   cur_mergeclauses,
-									   outerkeys,
-									   innerkeys,
-									   jointype,
-									   extra);
+			try_mergejoin_path_common(root, joinrel,
+									  cheapest_partial_outer,
+									  cheapest_safe_inner,
+									  merge_pathkeys, cur_mergeclauses,
+									  outerkeys, innerkeys, jointype, extra,
+									  true, grouped_outer, grouped_inner,
+									  do_aggregate);
 	}
 }
 
@@ -1069,6 +1701,14 @@ sort_inner_and_outer(PlannerInfo *root,
  * some sort key requirements).  So, we consider truncations of the
  * mergeclause list as well as the full list.  (Ideally we'd consider all
  * subsets of the mergeclause list, but that seems way too expensive.)
+ *
+ * grouped_outer - is outerpath grouped?
+ * grouped_inner - use grouped paths of innerrel?
+ * do_aggregate - apply (partial) aggregation to the output?
+ *
+ * TODO If subsequent calls often differ only by the 3 arguments above,
+ * consider a workspace structure to share useful info (eg merge clauses)
+ * across calls.
  */
 static void
 generate_mergejoin_paths(PlannerInfo *root,
@@ -1080,7 +1720,10 @@ generate_mergejoin_paths(PlannerInfo *root,
 						 bool useallclauses,
 						 Path *inner_cheapest_total,
 						 List *merge_pathkeys,
-						 bool is_partial)
+						 bool is_partial,
+						 bool grouped_outer,
+						 bool grouped_inner,
+						 bool do_aggregate)
 {
 	List	   *mergeclauses;
 	List	   *innersortkeys;
@@ -1131,17 +1774,18 @@ generate_mergejoin_paths(PlannerInfo *root,
 	 * try_mergejoin_path will do the right thing if inner_cheapest_total is
 	 * already correctly sorted.)
 	 */
-	try_mergejoin_path(root,
-					   joinrel,
-					   outerpath,
-					   inner_cheapest_total,
-					   merge_pathkeys,
-					   mergeclauses,
-					   NIL,
-					   innersortkeys,
-					   jointype,
-					   extra,
-					   is_partial);
+	try_mergejoin_path_common(root,
+							  joinrel,
+							  outerpath,
+							  inner_cheapest_total,
+							  merge_pathkeys,
+							  mergeclauses,
+							  NIL,
+							  innersortkeys,
+							  jointype,
+							  extra,
+							  is_partial,
+							  grouped_outer, grouped_inner, do_aggregate);
 
 	/* Can't do anything else if inner path needs to be unique'd */
 	if (save_jointype == JOIN_UNIQUE_INNER)
@@ -1197,16 +1841,22 @@ generate_mergejoin_paths(PlannerInfo *root,
 
 	for (sortkeycnt = num_sortkeys; sortkeycnt > 0; sortkeycnt--)
 	{
+		List	   *inner_pathlist = NIL;
 		Path	   *innerpath;
 		List	   *newclauses = NIL;
 
+		if (!grouped_inner)
+			inner_pathlist = innerrel->pathlist;
+		else if (innerrel->gpi != NULL)
+			inner_pathlist = innerrel->gpi->pathlist;
+
 		/*
 		 * Look for an inner path ordered well enough for the first
 		 * 'sortkeycnt' innersortkeys.  NB: trialsortkeys list is modified
 		 * destructively, which is why we made a copy...
 		 */
 		trialsortkeys = list_truncate(trialsortkeys, sortkeycnt);
-		innerpath = get_cheapest_path_for_pathkeys(innerrel->pathlist,
+		innerpath = get_cheapest_path_for_pathkeys(inner_pathlist,
 												   trialsortkeys,
 												   NULL,
 												   TOTAL_COST,
@@ -1229,21 +1879,25 @@ generate_mergejoin_paths(PlannerInfo *root,
 			}
 			else
 				newclauses = mergeclauses;
-			try_mergejoin_path(root,
-							   joinrel,
-							   outerpath,
-							   innerpath,
-							   merge_pathkeys,
-							   newclauses,
-							   NIL,
-							   NIL,
-							   jointype,
-							   extra,
-							   is_partial);
+
+			try_mergejoin_path_common(root,
+									  joinrel,
+									  outerpath,
+									  innerpath,
+									  merge_pathkeys,
+									  newclauses,
+									  NIL,
+									  NIL,
+									  jointype,
+									  extra,
+									  is_partial,
+									  grouped_outer, grouped_inner,
+									  do_aggregate);
+
 			cheapest_total_inner = innerpath;
 		}
 		/* Same on the basis of cheapest startup cost ... */
-		innerpath = get_cheapest_path_for_pathkeys(innerrel->pathlist,
+		innerpath = get_cheapest_path_for_pathkeys(inner_pathlist,
 												   trialsortkeys,
 												   NULL,
 												   STARTUP_COST,
@@ -1274,17 +1928,19 @@ generate_mergejoin_paths(PlannerInfo *root,
 					else
 						newclauses = mergeclauses;
 				}
-				try_mergejoin_path(root,
-								   joinrel,
-								   outerpath,
-								   innerpath,
-								   merge_pathkeys,
-								   newclauses,
-								   NIL,
-								   NIL,
-								   jointype,
-								   extra,
-								   is_partial);
+				try_mergejoin_path_common(root,
+										  joinrel,
+										  outerpath,
+										  innerpath,
+										  merge_pathkeys,
+										  newclauses,
+										  NIL,
+										  NIL,
+										  jointype,
+										  extra,
+										  is_partial,
+										  grouped_outer, grouped_inner,
+										  do_aggregate);
 			}
 			cheapest_startup_inner = innerpath;
 		}
@@ -1297,43 +1953,32 @@ generate_mergejoin_paths(PlannerInfo *root,
 	}
 }
 
+
 /*
- * match_unsorted_outer
- *	  Creates possible join paths for processing a single join relation
- *	  'joinrel' by employing either iterative substitution or
- *	  mergejoining on each of its possible outer paths (considering
- *	  only outer paths that are already ordered well enough for merging).
- *
- * We always generate a nestloop path for each available outer path.
- * In fact we may generate as many as five: one on the cheapest-total-cost
- * inner path, one on the same with materialization, one on the
- * cheapest-startup-cost inner path (if different), one on the
- * cheapest-total inner-indexscan path (if any), and one on the
- * cheapest-startup inner-indexscan path (if different).
- *
- * We also consider mergejoins if mergejoin clauses are available.  See
- * detailed comments in generate_mergejoin_paths.
- *
- * 'joinrel' is the join relation
- * 'outerrel' is the outer join relation
- * 'innerrel' is the inner join relation
- * 'jointype' is the type of join to do
- * 'extra' contains additional input values
+ * TODO As merge_pathkeys shouldn't differ across calls, use a separate
+ * function to derive them and pass them here in a list.
  */
 static void
-match_unsorted_outer(PlannerInfo *root,
-					 RelOptInfo *joinrel,
-					 RelOptInfo *outerrel,
-					 RelOptInfo *innerrel,
-					 JoinType jointype,
-					 JoinPathExtraData *extra)
+match_unsorted_outer_common(PlannerInfo *root,
+							RelOptInfo *joinrel,
+							RelOptInfo *outerrel,
+							RelOptInfo *innerrel,
+							JoinType jointype,
+							JoinPathExtraData *extra,
+							bool grouped_outer,
+							bool grouped_inner,
+							bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
 	bool		nestjoinOK;
 	bool		useallclauses;
-	Path	   *inner_cheapest_total = innerrel->cheapest_total_path;
+	Path	   *inner_cheapest_total;
 	Path	   *matpath = NULL;
 	ListCell   *lc1;
+	List	   *outer_pathlist;
+
+	/* At most one input path may be grouped. */
+	Assert(!(grouped_outer && grouped_inner));
 
 	/*
 	 * Nestloop only supports inner, left, semi, and anti joins.  Also, if we
@@ -1370,13 +2015,38 @@ match_unsorted_outer(PlannerInfo *root,
 			break;
 	}
 
+	if (grouped_outer)
+	{
+		if (REL_HAS_GROUPED_PATHS(outerrel))
+			outer_pathlist = outerrel->gpi->pathlist;
+		else
+			return;
+	}
+	else
+		outer_pathlist = outerrel->pathlist;
+
+	if (grouped_inner)
+	{
+		if (REL_HAS_GROUPED_PATHS(innerrel))
+			inner_cheapest_total = linitial(innerrel->gpi->pathlist);
+		else
+			return;
+	}
+	else
+		inner_cheapest_total = innerrel->cheapest_total_path;
+
 	/*
 	 * If inner_cheapest_total is parameterized by the outer rel, ignore it;
 	 * we will consider it below as a member of cheapest_parameterized_paths,
 	 * but the other possibilities considered in this routine aren't usable.
 	 */
 	if (PATH_PARAM_BY_REL(inner_cheapest_total, outerrel))
+	{
+		/* Grouped path should not be parameterized at all. */
+		Assert(!grouped_inner);
+
 		inner_cheapest_total = NULL;
+	}
 
 	/*
 	 * If we need to unique-ify the inner path, we will consider only the
@@ -1387,16 +2057,31 @@ match_unsorted_outer(PlannerInfo *root,
 		/* No way to do this with an inner path parameterized by outer rel */
 		if (inner_cheapest_total == NULL)
 			return;
+
+		/*
+		 * TODO This is just a temporary limitation. Before lifting it, make
+		 * sure that the UniquePath does emit GroupedVars. Also try to avoid
+		 * the unique-ification if outer_path comes directly from AggPath
+		 * (i.e. it's not grouped path combined with plain one) and the
+		 * grouping keys guaranteed the uniqueness.
+		 */
+		if (grouped_inner)
+			return;
+
 		inner_cheapest_total = (Path *)
 			create_unique_path(root, innerrel, inner_cheapest_total, extra->sjinfo);
 		Assert(inner_cheapest_total);
 	}
-	else if (nestjoinOK)
+	else if (nestjoinOK && !grouped_inner)
 	{
 		/*
 		 * Consider materializing the cheapest inner path, unless
 		 * enable_material is off or the path in question materializes its
 		 * output anyway.
+		 *
+		 * TODO Verify that this is ok even if grouped_inner is true (at least
+		 * make sure that mathpath does contain GroupedVars) and remove
+		 * grouped_inner from the condition above.
 		 */
 		if (enable_material && inner_cheapest_total != NULL &&
 			!ExecMaterializesOutput(inner_cheapest_total->pathtype))
@@ -1404,7 +2089,7 @@ match_unsorted_outer(PlannerInfo *root,
 				create_material_path(innerrel, inner_cheapest_total);
 	}
 
-	foreach(lc1, outerrel->pathlist)
+	foreach(lc1, outer_pathlist)
 	{
 		Path	   *outerpath = (Path *) lfirst(lc1);
 		List	   *merge_pathkeys;
@@ -1424,6 +2109,11 @@ match_unsorted_outer(PlannerInfo *root,
 		{
 			if (outerpath != outerrel->cheapest_total_path)
 				continue;
+
+			/* TODO Temporary restriction, see above. */
+			if (grouped_outer)
+				continue;
+
 			outerpath = (Path *) create_unique_path(root, outerrel,
 													outerpath, extra->sjinfo);
 			Assert(outerpath);
@@ -1439,17 +2129,23 @@ match_unsorted_outer(PlannerInfo *root,
 
 		if (save_jointype == JOIN_UNIQUE_INNER)
 		{
+			/* TODO Temporary restriction, see above. */
+			if (grouped_inner)
+				continue;
+
 			/*
 			 * Consider nestloop join, but only with the unique-ified cheapest
 			 * inner path
 			 */
-			try_nestloop_path(root,
-							  joinrel,
-							  outerpath,
-							  inner_cheapest_total,
-							  merge_pathkeys,
-							  jointype,
-							  extra);
+			try_nestloop_path_common(root,
+									 joinrel,
+									 outerpath,
+									 inner_cheapest_total,
+									 merge_pathkeys,
+									 jointype,
+									 extra,
+									 false, grouped_outer, grouped_inner,
+									 do_aggregate);
 		}
 		else if (nestjoinOK)
 		{
@@ -1461,28 +2157,40 @@ match_unsorted_outer(PlannerInfo *root,
 			 */
 			ListCell   *lc2;
 
-			foreach(lc2, innerrel->cheapest_parameterized_paths)
+			/*
+			 * There are no grouped paths in cheapest_parameterized_paths.
+			 */
+			if (!grouped_inner)
 			{
-				Path	   *innerpath = (Path *) lfirst(lc2);
+				foreach(lc2, innerrel->cheapest_parameterized_paths)
+				{
+					Path	   *innerpath = (Path *) lfirst(lc2);
 
-				try_nestloop_path(root,
-								  joinrel,
-								  outerpath,
-								  innerpath,
-								  merge_pathkeys,
-								  jointype,
-								  extra);
+					try_nestloop_path_common(root,
+											 joinrel,
+											 outerpath,
+											 innerpath,
+											 merge_pathkeys,
+											 jointype,
+											 extra,
+											 false, grouped_outer, grouped_inner,
+											 do_aggregate);
+				}
 			}
 
-			/* Also consider materialized form of the cheapest inner path */
+			/*
+			 * Also consider materialized form of the cheapest inner path.
+			 */
 			if (matpath != NULL)
-				try_nestloop_path(root,
-								  joinrel,
-								  outerpath,
-								  matpath,
-								  merge_pathkeys,
-								  jointype,
-								  extra);
+				try_nestloop_path_common(root,
+										 joinrel,
+										 outerpath,
+										 matpath,
+										 merge_pathkeys,
+										 jointype,
+										 extra,
+										 false, grouped_outer, grouped_inner,
+										 do_aggregate);
 		}
 
 		/* Can't do anything else if outer path needs to be unique'd */
@@ -1497,7 +2205,8 @@ match_unsorted_outer(PlannerInfo *root,
 		generate_mergejoin_paths(root, joinrel, innerrel, outerpath,
 								 save_jointype, extra, useallclauses,
 								 inner_cheapest_total, merge_pathkeys,
-								 false);
+								 false, grouped_outer, grouped_inner,
+								 do_aggregate);
 	}
 
 	/*
@@ -1508,17 +2217,23 @@ match_unsorted_outer(PlannerInfo *root,
 	 * we handle extra_lateral_rels, since partial paths must not be
 	 * parameterized. Similarly, we can't handle JOIN_FULL and JOIN_RIGHT,
 	 * because they can produce false null extended rows.
+	 *
+	 * grouped_inner must be false because we're not interested in nest loop
+	 * joins with the grouped path on the inner side (i.e. repeated
+	 * aggregation).
 	 */
 	if (joinrel->consider_parallel &&
 		save_jointype != JOIN_UNIQUE_OUTER &&
 		save_jointype != JOIN_FULL &&
 		save_jointype != JOIN_RIGHT &&
 		outerrel->partial_pathlist != NIL &&
-		bms_is_empty(joinrel->lateral_relids))
+		bms_is_empty(joinrel->lateral_relids) &&
+		!grouped_inner)
 	{
 		if (nestjoinOK)
 			consider_parallel_nestloop(root, joinrel, outerrel, innerrel,
-									   save_jointype, extra);
+									   save_jointype, extra,
+									   grouped_outer, do_aggregate);
 
 		/*
 		 * If inner_cheapest_total is NULL or non parallel-safe then find the
@@ -1538,11 +2253,58 @@ match_unsorted_outer(PlannerInfo *root,
 		if (inner_cheapest_total)
 			consider_parallel_mergejoin(root, joinrel, outerrel, innerrel,
 										save_jointype, extra,
-										inner_cheapest_total);
+										inner_cheapest_total,
+										grouped_outer, do_aggregate);
 	}
 }
 
 /*
+ * match_unsorted_outer
+ *	  Creates possible join paths for processing a single join relation
+ *	  'joinrel' by employing either iterative substitution or
+ *	  mergejoining on each of its possible outer paths (considering
+ *	  only outer paths that are already ordered well enough for merging).
+ *
+ * We always generate a nestloop path for each available outer path.
+ * In fact we may generate as many as five: one on the cheapest-total-cost
+ * inner path, one on the same with materialization, one on the
+ * cheapest-startup-cost inner path (if different), one on the
+ * cheapest-total inner-indexscan path (if any), and one on the
+ * cheapest-startup inner-indexscan path (if different).
+ *
+ * We also consider mergejoins if mergejoin clauses are available.  See
+ * detailed comments in generate_mergejoin_paths.
+ *
+ * 'joinrel' is the join relation
+ * 'outerrel' is the outer join relation
+ * 'innerrel' is the inner join relation
+ * 'jointype' is the type of join to do
+ * 'extra' contains additional input values
+ * 'grouped' indicates that the at least one relation in the join has been
+ * aggregated.
+ */
+static void
+match_unsorted_outer(PlannerInfo *root,
+					 RelOptInfo *joinrel,
+					 RelOptInfo *outerrel,
+					 RelOptInfo *innerrel,
+					 JoinType jointype,
+					 JoinPathExtraData *extra)
+{
+	/* Plain (non-grouped) join. */
+	match_unsorted_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, false, false);
+
+	/* Use all the supported strategies to generate grouped join. */
+	match_unsorted_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, true, false, false);
+	match_unsorted_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, true, false);
+	match_unsorted_outer_common(root, joinrel, outerrel, innerrel,
+								jointype, extra, false, false, true);
+}
+
+/*
  * consider_parallel_mergejoin
  *	  Try to build partial paths for a joinrel by joining a partial path
  *	  for the outer relation to a complete path for the inner relation.
@@ -1554,6 +2316,10 @@ match_unsorted_outer(PlannerInfo *root,
  * 'extra' contains additional input values
  * 'inner_cheapest_total' cheapest total path for innerrel
  */
+/*
+ * TODO Store merge_pathkeys across calls if these (the calls) only differ in
+ * grouped_outer or do_aggregate.
+ */
 static void
 consider_parallel_mergejoin(PlannerInfo *root,
 							RelOptInfo *joinrel,
@@ -1561,12 +2327,36 @@ consider_parallel_mergejoin(PlannerInfo *root,
 							RelOptInfo *innerrel,
 							JoinType jointype,
 							JoinPathExtraData *extra,
-							Path *inner_cheapest_total)
+							Path *inner_cheapest_total,
+							bool grouped_outer,
+							bool do_aggregate)
 {
 	ListCell   *lc1;
+	List	   *outer_pathlist;
+	bool		grouped = grouped_outer || do_aggregate;
+
+	if (!grouped || do_aggregate)
+	{
+		/*
+		 * If creating grouped paths by explicit aggregation, the input paths
+		 * must be plain.
+		 */
+		outer_pathlist = outerrel->partial_pathlist;
+	}
+	else if (outerrel->gpi != NULL)
+	{
+		/*
+		 * Only the outer paths are accepted as grouped when we try to combine
+		 * grouped and plain ones. Grouped inner path implies repeated
+		 * aggregation, which doesn't sound as a good idea.
+		 */
+		outer_pathlist = outerrel->gpi->partial_pathlist;
+	}
+	else
+		return;
 
 	/* generate merge join path for each partial outer path */
-	foreach(lc1, outerrel->partial_pathlist)
+	foreach(lc1, outer_pathlist)
 	{
 		Path	   *outerpath = (Path *) lfirst(lc1);
 		List	   *merge_pathkeys;
@@ -1577,9 +2367,10 @@ consider_parallel_mergejoin(PlannerInfo *root,
 		merge_pathkeys = build_join_pathkeys(root, joinrel, jointype,
 											 outerpath->pathkeys);
 
-		generate_mergejoin_paths(root, joinrel, innerrel, outerpath, jointype,
-								 extra, false, inner_cheapest_total,
-								 merge_pathkeys, true);
+		generate_mergejoin_paths(root, joinrel, innerrel, outerpath,
+								 jointype, extra, false,
+								 inner_cheapest_total, merge_pathkeys,
+								 true, grouped_outer, false, do_aggregate);
 	}
 }
 
@@ -1594,21 +2385,48 @@ consider_parallel_mergejoin(PlannerInfo *root,
  * 'jointype' is the type of join to do
  * 'extra' contains additional input values
  */
+/*
+ * TODO Store pathkeys across calls if these (the calls) only differ in
+ * grouped_outer or do_aggregate.
+ */
 static void
 consider_parallel_nestloop(PlannerInfo *root,
 						   RelOptInfo *joinrel,
 						   RelOptInfo *outerrel,
 						   RelOptInfo *innerrel,
 						   JoinType jointype,
-						   JoinPathExtraData *extra)
+						   JoinPathExtraData *extra,
+						   bool grouped_outer, bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
+	List	   *outer_pathlist;
 	ListCell   *lc1;
+	bool		grouped = grouped_outer || do_aggregate;
 
 	if (jointype == JOIN_UNIQUE_INNER)
 		jointype = JOIN_INNER;
 
-	foreach(lc1, outerrel->partial_pathlist)
+	if (!grouped || do_aggregate)
+	{
+		/*
+		 * If creating grouped paths by explicit aggregation, the input paths
+		 * must be plain.
+		 */
+		outer_pathlist = outerrel->partial_pathlist;
+	}
+	else if (outerrel->gpi != NULL)
+	{
+		/*
+		 * Only the outer paths are accepted as grouped when we try to combine
+		 * grouped and plain ones. Grouped inner path implies repeated
+		 * aggregation, which doesn't sound as a good idea.
+		 */
+		outer_pathlist = outerrel->gpi->partial_pathlist;
+	}
+	else
+		return;
+
+	foreach(lc1, outer_pathlist)
 	{
 		Path	   *outerpath = (Path *) lfirst(lc1);
 		List	   *pathkeys;
@@ -1639,7 +2457,7 @@ consider_parallel_nestloop(PlannerInfo *root,
 			 * inner paths, but right now create_unique_path is not on board
 			 * with that.)
 			 */
-			if (save_jointype == JOIN_UNIQUE_INNER)
+			if (save_jointype == JOIN_UNIQUE_INNER && !grouped)
 			{
 				if (innerpath != innerrel->cheapest_total_path)
 					continue;
@@ -1649,30 +2467,29 @@ consider_parallel_nestloop(PlannerInfo *root,
 				Assert(innerpath);
 			}
 
-			try_partial_nestloop_path(root, joinrel, outerpath, innerpath,
-									  pathkeys, jointype, extra);
+			try_nestloop_path_common(root, joinrel, outerpath, innerpath,
+									 pathkeys, jointype, extra,
+									 true, grouped_outer, false,
+									 do_aggregate);
 		}
 	}
 }
 
 /*
- * hash_inner_and_outer
- *	  Create hashjoin join paths by explicitly hashing both the outer and
- *	  inner keys of each available hash clause.
- *
- * 'joinrel' is the join relation
- * 'outerrel' is the outer join relation
- * 'innerrel' is the inner join relation
- * 'jointype' is the type of join to do
- * 'extra' contains additional input values
+ * TODO hashclauses (and mabye some other info) should be shared across calls
+ * if only some of the following arguments change: partial, grouped_outer,
+ * grouped_inner, do_aggregate.
  */
 static void
-hash_inner_and_outer(PlannerInfo *root,
-					 RelOptInfo *joinrel,
-					 RelOptInfo *outerrel,
-					 RelOptInfo *innerrel,
-					 JoinType jointype,
-					 JoinPathExtraData *extra)
+hash_inner_and_outer_common(PlannerInfo *root,
+							RelOptInfo *joinrel,
+							RelOptInfo *outerrel,
+							RelOptInfo *innerrel,
+							JoinType jointype,
+							JoinPathExtraData *extra,
+							bool grouped_outer,
+							bool grouped_inner,
+							bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
 	bool		isouterjoin = IS_OUTER_JOIN(jointype);
@@ -1719,9 +2536,36 @@ hash_inner_and_outer(PlannerInfo *root,
 		 * outer paths.  There's no need to consider any but the
 		 * cheapest-total-cost inner path, however.
 		 */
-		Path	   *cheapest_startup_outer = outerrel->cheapest_startup_path;
-		Path	   *cheapest_total_outer = outerrel->cheapest_total_path;
-		Path	   *cheapest_total_inner = innerrel->cheapest_total_path;
+		Path	   *cheapest_startup_outer,
+				   *cheapest_total_outer,
+				   *cheapest_total_inner;
+
+		if (grouped_outer)
+		{
+			if (REL_HAS_GROUPED_PATHS(outerrel))
+			{
+				cheapest_total_outer = linitial(outerrel->gpi->pathlist);
+				/* No parameterized grouped paths. */
+				cheapest_startup_outer = NULL;
+			}
+			else
+				return;
+		}
+		else
+		{
+			cheapest_total_outer = outerrel->cheapest_total_path;
+			cheapest_startup_outer = outerrel->cheapest_startup_path;
+		}
+
+		if (grouped_inner)
+		{
+			if (REL_HAS_GROUPED_PATHS(innerrel))
+				cheapest_total_inner = linitial(innerrel->gpi->pathlist);
+			else
+				return;
+		}
+		else
+			cheapest_total_inner = innerrel->cheapest_total_path;
 
 		/*
 		 * If either cheapest-total path is parameterized by the other rel, we
@@ -1736,43 +2580,66 @@ hash_inner_and_outer(PlannerInfo *root,
 		/* Unique-ify if need be; we ignore parameterized possibilities */
 		if (jointype == JOIN_UNIQUE_OUTER)
 		{
+			/*
+			 * TODO This is just a temporary limitation. Before lifting it,
+			 * make sure that the UniquePath does emit GroupedVars. Also try
+			 * to avoid the unique-ification if the outer path comes directly
+			 * from AggPath (i.e. it's not grouped path combined with plain
+			 * one) and the grouping keys guaranteed the uniqueness.
+			 */
+			if (grouped_outer)
+				return;
+
 			cheapest_total_outer = (Path *)
 				create_unique_path(root, outerrel,
 								   cheapest_total_outer, extra->sjinfo);
 			Assert(cheapest_total_outer);
 			jointype = JOIN_INNER;
-			try_hashjoin_path(root,
-							  joinrel,
-							  cheapest_total_outer,
-							  cheapest_total_inner,
-							  hashclauses,
-							  jointype,
-							  extra);
+			try_hashjoin_path_common(root,
+									 joinrel,
+									 cheapest_total_outer,
+									 cheapest_total_inner,
+									 hashclauses,
+									 jointype,
+									 extra,
+									 false, grouped_outer, grouped_inner,
+									 do_aggregate);
 			/* no possibility of cheap startup here */
 		}
 		else if (jointype == JOIN_UNIQUE_INNER)
 		{
+			/* TODO Temporary restriction, see above. */
+			if (grouped_inner)
+				return;
+
 			cheapest_total_inner = (Path *)
 				create_unique_path(root, innerrel,
 								   cheapest_total_inner, extra->sjinfo);
 			Assert(cheapest_total_inner);
 			jointype = JOIN_INNER;
-			try_hashjoin_path(root,
-							  joinrel,
-							  cheapest_total_outer,
-							  cheapest_total_inner,
-							  hashclauses,
-							  jointype,
-							  extra);
+			try_hashjoin_path_common(root,
+									 joinrel,
+									 cheapest_total_outer,
+									 cheapest_total_inner,
+									 hashclauses,
+									 jointype,
+									 extra,
+									 false,
+									 grouped_outer, grouped_inner,
+									 do_aggregate);
+
 			if (cheapest_startup_outer != NULL &&
 				cheapest_startup_outer != cheapest_total_outer)
-				try_hashjoin_path(root,
-								  joinrel,
-								  cheapest_startup_outer,
-								  cheapest_total_inner,
-								  hashclauses,
-								  jointype,
-								  extra);
+				try_hashjoin_path_common(root,
+										 joinrel,
+										 cheapest_startup_outer,
+										 cheapest_total_inner,
+										 hashclauses,
+										 jointype,
+										 extra,
+										 false,
+										 grouped_outer, grouped_inner,
+										 do_aggregate);
 		}
 		else
 		{
@@ -1782,22 +2649,35 @@ hash_inner_and_outer(PlannerInfo *root,
 			 * pairings of cheapest-total paths including parameterized ones.
 			 * There is no use in generating parameterized paths on the basis
 			 * of possibly cheap startup cost, so this is sufficient.
+			 *
+			 * For if either side of the join is grouped, we simply use
+			 * rel->gpi->pathlist. (cheapest_startup_outer should be NULL if
+			 * grouped_outer.)
 			 */
 			ListCell   *lc1;
 			ListCell   *lc2;
+			List	   *outer_pathlist;
 
 			if (cheapest_startup_outer != NULL)
-				try_hashjoin_path(root,
-								  joinrel,
-								  cheapest_startup_outer,
-								  cheapest_total_inner,
-								  hashclauses,
-								  jointype,
-								  extra);
-
-			foreach(lc1, outerrel->cheapest_parameterized_paths)
+				try_hashjoin_path_common(root,
+										 joinrel,
+										 cheapest_startup_outer,
+										 cheapest_total_inner,
+										 hashclauses,
+										 jointype,
+										 extra,
+										 false,
+										 grouped_outer, grouped_inner,
+										 do_aggregate);
+
+			outer_pathlist = !grouped_outer ?
+				outerrel->cheapest_parameterized_paths :
+				outerrel->gpi->pathlist;
+
+			foreach(lc1, outer_pathlist)
 			{
 				Path	   *outerpath = (Path *) lfirst(lc1);
+				List	   *inner_pathlist;
 
 				/*
 				 * We cannot use an outer path that is parameterized by the
@@ -1806,7 +2686,11 @@ hash_inner_and_outer(PlannerInfo *root,
 				if (PATH_PARAM_BY_REL(outerpath, innerrel))
 					continue;
 
-				foreach(lc2, innerrel->cheapest_parameterized_paths)
+				inner_pathlist = !grouped_inner ?
+					innerrel->cheapest_parameterized_paths :
+					innerrel->gpi->pathlist;
+
+				foreach(lc2, inner_pathlist)
 				{
 					Path	   *innerpath = (Path *) lfirst(lc2);
 
@@ -1821,13 +2705,16 @@ hash_inner_and_outer(PlannerInfo *root,
 						innerpath == cheapest_total_inner)
 						continue;	/* already tried it */
 
-					try_hashjoin_path(root,
-									  joinrel,
-									  outerpath,
-									  innerpath,
-									  hashclauses,
-									  jointype,
-									  extra);
+					try_hashjoin_path_common(root,
+											 joinrel,
+											 outerpath,
+											 innerpath,
+											 hashclauses,
+											 jointype,
+											 extra,
+											 false,
+											 grouped_outer, grouped_inner,
+											 do_aggregate);
 				}
 			}
 		}
